import DataUtils from "../utils/DataUtils";
import SimpleMarkerLayer from "../common/SimpleMarkerLayer";

/**
 * 定义接驳井图层
 */
 export default class ConnholeLayer {
  /**
   * 构造函数
   * @param {Object} options -图层选线
   */
  constructor(options) {
    /**
   * 地图对象
   * @type {Object}
   */
    this._map = options.map;

    /**
     * 最小缩放层级
     * @type {Number}
     */
    this._minzoom = DataUtils.default(options.minzoom, 10);

    /**
     * 图标ID
     * @type {String}
     */
    this._icon = DataUtils.default(options.icon, 'connhole');

    /**
     * 字段名
     * @type {String}
     */
    this._fieldName = DataUtils.default(options.field, undefined);

    /**
     * 过滤条件数组
     * @type {Array}
     */
    this._filter = DataUtils.default(options.filter, undefined);

    /**
     * 数据源ID
     * @type {String}
     */
    this._sourceId = DataUtils.default(options.sourceId, 'pipe_connhole');

    /**
     * 图层ID
     * @type {String}
     */
    this._layerId = DataUtils.default(options.layerId, this._sourceId);

    // 初始化图层
    this._markerLayer = new SimpleMarkerLayer({
      map: this._map,
      minzoom: this._minzoom,
      icon: this._icon,
      field: this._fieldName,
      filter: this._filter,
      sourceId: this._sourceId,
      layerId: this._layerId
    });
  }

  /**
   * 设置数据
   * @param {Array|Object|String} data -数据
   */
  setData(data) {
    // 加载图层
    this.loadLayer();

    if (data) {
      this._markerLayer.setData(data);
    }
  }

  /**
   * 设置过滤器
   * @param {Array} filter -过滤器
   */
  setFilter(filter) {
    this._markerLayer.setFilter(filter);
  }

  /**
   * 加载图层
   */
  loadLayer() {
    if (!this.hasLayer()) {
      this._markerLayer.loadLayer();
    }

    // 显示图层
    this.showLayer(true);
  }

  /**
   * 显示/隐藏图层
   * @param {Boolean} isShow -是否显示图层
   */
  showLayer(isShow) {
    this._markerLayer.showLayer(isShow);
  }

  /**
   * 判断图层是否已加载
   *
   * @returns {Boolean}
   */
  hasLayer() {
    return this._markerLayer.hasLayer();
  }

  /**
   * 移除图层
   */
  removeLayer() {
    this._markerLayer.removeLayer();
    // 移除数据源
    this._markerLayer.removeSource();
  }


  /**
   * 绑定单击事件
   * @param {Function} event -事件函数
   */
  onClick(event) {
    this._markerLayer.onClick(event);
  }
}
